version: "3.8"

# All Services
services:

  geoserver:
    image: docker.cmclinnovations.com/geoserver:${GEOSERVER_VERSION}
    build:
      context: geoserver
      args:
        GEOSERVER_VERSION: ${GEOSERVER_VERSION}
    container_name: "geoserver"
    environment:
      PLUGIN_DYNAMIC_URLS: "http://sourceforge.net/projects/geoserver/files/GeoServer/${GEOSERVER_VERSION}/extensions/geoserver-${GEOSERVER_VERSION}-vectortiles-plugin.zip"
      DATA_IN_DIR: "/inputs/${GEOTIF_DIR}"
    env_file:
      - .env
      - geoserver/geoserver.env
    network_name: ${NETWORK_NAME}
    ports:
      - ${GEOSERVER_PORT}:8080
    restart: unless-stopped
    security_opt:
      - label=disable
    volumes:
      - vis_data:/inputs
      - geoserver_datadir:${GEOSERVER_DATA_DIR}
      - geoserver_grib_cache:${GRIB_CACHE_DIR}
      - geoserver_gwc:${GEOWEBCACHE_CACHE_DIR}
      - geoserver_gwc_config:${GEOWEBCACHE_CONFIG_DIR}
      - geoserver_logs:${GEOSERVER_LOG_DIR}
      - geoserver_netcfd:${NETCDF_DATA_DIR}

  # CReDo visualisation
  credo-vis:
    image: docker.cmclinnovations.com/credo-vis:1.0.0-SNAPSHOT
    container_name: "credo-vis"
    environment:
      GEOSERVER_HOST: "${GEOSERVER_HOST}"
      GEOSERVER_PORT: "${GEOSERVER_PORT}"
    network_name: ${NETWORK_NAME}
    restart: unless-stopped
    build:
      context: "./vis"
      dockerfile: "./docker/Dockerfile"
      labels:
        authors: "support@cmclinnovations"
        description: "CReDo visualisation."
    security_opt:
      - label=disable
    ports:
      - ${VIS_PORT}:80
    volumes:
      - vis_data:/var/www/html/data
      - ../../docs:/var/www/html/docs:z

# The default network name is set using a docker-compose environment variable.
# Please don't modify the contents of the 'networks' node below.
networks:
  default:
    name: ${NETWORK_NAME}

volumes:
  vis_data: null
  geoserver_datadir: null
  geoserver_grib_cache: null
  geoserver_gwc: null
  geoserver_gwc_config: null
  geoserver_logs: null
  geoserver_netcfd: null
